#!/usr/bin/env python
# coding: utf-8

import socket
import threading
import struct
from VectalisCore.XmlSerializer import XmlSerializer
from VectalisCore.Communication.ClientRequest import ClientRequest

# Simple python server that accept socket on multithread mode
class TcpServer:
    def __init__(self, processFunc):
        self.processFunc = processFunc

    def run(self):
        self.listen_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        try:
            port = 6000
            ipAddress = '127.0.0.1'
            nbBacklogConnection = 5
            timeout = 0.5

            self.listen_socket.bind((ipAddress, port))
            self.listen_socket.listen(nbBacklogConnection)
            print ("Server listen at " + ipAddress + ":" + str(port))
            print ("UTS config should look like:")
            print ("  Pricer Bridge Technology: Remoting")
            print ("  Pricer Version: " + XmlSerializer.utsPricerMessageVersion)
            print ("  PricingParameters: mode=TcpServer;address=" + ipAddress + ";port=" + str(port))
            print ("  Pricer Service: tcp://" + ipAddress + ":7777/PricingService")
            print ("Waiting Request...")
            self.listen_socket.settimeout(timeout)# Stop on Control+C
            while 1:
                try:
                    conn, address = self.listen_socket.accept()
                except socket.timeout:
                    pass
                else:
                    request = ClientRequest(conn, address, self.processFunc)
                    request.start()
        finally:
            self.listen_socket.close()

